//GAMY: a tool for estimating the similarity of graphs
//	Copyright(C) 2019 Mattia De Prisco and Giovanni Squillero
//
//	This program is free software : you can redistribute it and /or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.If not, see < http://www.gnu.org/licenses/>.

/*-*
 * Supports the basic selection methodologies from EC and other utilities
 *-*/

#include "selector.h"

#ifdef USE_FAST_RANDOM

// the oldest and best�known pseudorandom number generator, probably enough.
//std::minstd_rand Shared_random_engine(static_cast<unsigned int>(std::time(NULL)));
std::minstd_rand shared_random_engine(static_cast<unsigned int>(42));

#else

// the famous 64-bit mersenne twister by matsumoto & nishimura... is it really needed?
std::mt19937_64 Shared_random_engine(std::seed_seq{
    static_cast<int>(std::time(NULL)), // seconds since the Era
    static_cast<int>(std::hash<std::thread::id>{}(std::this_thread::get_id())) // use template specialization to get the hashed thread_id as size_t
    });

#endif // USE_FAST_RANDOM
