//GAMY: a tool for estimating the similarity of graphs
//	Copyright(C) 2019 Mattia De Prisco and Giovanni Squillero
//
//	This program is free software : you can redistribute it and /or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.If not, see < http://www.gnu.org/licenses/>.

#include "utils.h"
#include <string>
#include <cstring>

int ParseLine(char* line) {
	int i = strlen(line);
	const char* p = line;
	while (*p <'0' || *p > '9') p++;
	line[i - 3] = '\0';
	i = atoi(p);
	return i;
}

uint64_t Pair(uint32_t x, uint32_t y) {
	int64_t p = 0;
	int i = 0;
	while (x || y) {
		p |= (static_cast<uint64_t>(x & 1) << i);     x >>= 1;
		p |= (static_cast<uint64_t>(y & 1) << (i + 1)); y >>= 1;
		i += 2;
	}

	return p;
}

void Depair(uint64_t p, uint32_t& x, uint32_t& y) {
	x = 0;
	y = 0;
	int i = 0;
	while (p) {
		x |= (static_cast<uint32_t>(p & 1) << i); p >>= 1;
		y |= (static_cast<uint32_t>(p & 1) << i); p >>= 1;
		i++;
	}
}